using System;
using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices; 

namespace WinUsbDemo
{
    ///  <summary>
    ///  API declarations relating to file I/O (and used by WinUsb).
    ///  </summary>

    sealed internal class FileIO 
    {
        internal const Int16 FILE_ATTRIBUTE_NORMAL = ((Int16)(0X80));
        internal const Int32 FILE_FLAG_OVERLAPPED = 0X40000000;
        internal const Int16 FILE_SHARE_READ = 0X1;
        internal const Int16 FILE_SHARE_WRITE = 0X2;
        internal const UInt32 GENERIC_READ = 0X80000000;
        internal const UInt32 GENERIC_WRITE = 0X40000000;
        internal const Int32 INVALID_HANDLE_VALUE = -1;
        internal const Int16 OPEN_EXISTING = 3; 
        
        [ StructLayout( LayoutKind.Sequential ) ]
        internal struct SECURITY_ATTRIBUTES 
        {
            internal Int32 nLength;
            internal Int32 lpSecurityDescriptor;
            internal Int32 bInheritHandle; 
        }

        [DllImport("kernel32.dll", SetLastError = true)]
        internal static extern Boolean CloseHandle(SafeFileHandle hObject);

        [DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        internal static extern SafeFileHandle CreateFile(String lpFileName, UInt32 dwDesiredAccess, Int32 dwShareMode, ref SECURITY_ATTRIBUTES lpSecurityAttributes, Int32 dwCreationDisposition, Int32 dwFlagsAndAttributes, Int32 hTemplateFile);        
    }  
    
} 
